Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsxFileName = 'src/components/TYLists/items/slider-item.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactNative = require('react-native');

var _slider = require('../../slider');

var _slider2 = _interopRequireDefault(_slider);

var _defaultSvg = require('../../iconfont/svg/defaultSvg');

var _defaultSvg2 = _interopRequireDefault(_defaultSvg);

var _defaultSvg3 = require('../../iconfont/art/defaultSvg');

var _defaultSvg4 = _interopRequireDefault(_defaultSvg3);

var _utils = require('../../../utils');

var _styled = require('./styled');

var _styled2 = require('../styled');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isNil = _utils.CoreUtils.isNil;
var parseToStyle = _utils.ThemeUtils.parseToStyle;

var SliderItem = function (_Component) {
  _inherits(SliderItem, _Component);

  function SliderItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SliderItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SliderItem.__proto__ || Object.getPrototypeOf(SliderItem)).call.apply(_ref, [this].concat(args))), _this), _this.renderItem = function (isLeft) {
      var value = isLeft ? _this.props.Icon : _this.props.Action;
      var type = isLeft ? _this.props.iconType : _this.props.actionType;
      if (_react2.default.isValidElement(value)) {
        return value;
      }
      var itemComponent = void 0;
      if (type !== 'auto') {
        switch (type) {
          case 'image':
            itemComponent = _this.getImageComponent(value);
            break;
          case 'iconfont':
            itemComponent = _this.getIconComponent(value);
            break;
          case 'text':
          default:
            itemComponent = _this.getTextComponent(value);
            break;
        }
        return itemComponent && _react2.default.createElement(
          _styled.StyledPlaceholder,
          { alignLeft: isLeft, __source: {
              fileName: _jsxFileName,
              lineNumber: 172
            }
          },
          itemComponent
        );
      }
      switch (typeof value) {
        case 'function':
          itemComponent = value();
          break;
        case 'string':
          itemComponent = isLeft ? _this.getIconComponent(value) : _this.getTextComponent(value);
          break;
        case 'number':
          itemComponent = _this.getImageComponent(value);
          break;
        case 'object':
          {
            if (value && value.uri) {
              itemComponent = _this.getImageComponent(value);
            } else {
              itemComponent = value;
            }
            break;
          }
        default:
          itemComponent = null;
          break;
      }
      return itemComponent && _react2.default.createElement(
        _styled.StyledPlaceholder,
        { alignLeft: isLeft, __source: {
            fileName: _jsxFileName,
            lineNumber: 198
          }
        },
        itemComponent
      );
    }, _this.renderSlider = function () {
      var _this$props = _this.props,
          style = _this$props.style,
          iconType = _this$props.iconType,
          Icon = _this$props.Icon,
          actionType = _this$props.actionType,
          Action = _this$props.Action,
          iconSize = _this$props.iconSize,
          iconColor = _this$props.iconColor,
          textStyle = _this$props.textStyle,
          sliderStyle = _this$props.sliderStyle,
          sliderProps = _objectWithoutProperties(_this$props, ['style', 'iconType', 'Icon', 'actionType', 'Action', 'iconSize', 'iconColor', 'textStyle', 'sliderStyle']);

      return _react2.default.createElement(_slider2.default, _extends({ style: [{ flex: 1, alignSelf: 'stretch' }, sliderStyle] }, sliderProps, {
        __source: {
          fileName: _jsxFileName,
          lineNumber: 215
        }
      }));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SliderItem, [{
    key: 'getImageComponent',
    value: function getImageComponent(source) {
      var _props = this.props,
          theme = _props.theme,
          imageFollowIconColor = _props.imageFollowIconColor,
          iconSize = _props.iconSize,
          iconColor = _props.iconColor;

      return _react2.default.createElement(_styled2.StyledImage, {
        size: iconSize,
        iconColor: iconColor || theme.iconColor,
        source: source,
        imageFollowIconColor: imageFollowIconColor,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 119
        }
      });
    }
  }, {
    key: 'getIconComponent',
    value: function getIconComponent(data) {
      var _props2 = this.props,
          theme = _props2.theme,
          iconSize = _props2.iconSize,
          iconColor = _props2.iconColor,
          useART = _props2.useART;

      var svgMap = useART ? _defaultSvg4.default : _defaultSvg2.default;
      return _react2.default.createElement(_styled2.StyledIconFont, {
        size: iconSize,
        name: svgMap[data] ? data : undefined,
        d: data,
        color: iconColor || theme.iconColor,
        useART: useART,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 132
        }
      });
    }
  }, {
    key: 'getTextComponent',
    value: function getTextComponent(text) {
      var _props3 = this.props,
          theme = _props3.theme,
          textStyle = _props3.textStyle;

      return _react2.default.createElement(
        _styled2.StyledValueText,
        { style: [theme.descFontColor && { color: theme.descFontColor }, textStyle], __source: {
            fileName: _jsxFileName,
            lineNumber: 145
          }
        },
        text
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          theme = _props4.theme,
          style = _props4.style,
          contentStyle = _props4.contentStyle;

      var radiusStyle = !isNil(theme.cellRadius) && { borderRadius: theme.cellRadius };
      var itemStyle = [radiusStyle, theme.margin && parseToStyle(theme.margin, 'margin'), theme.cellBg && { backgroundColor: theme.cellBg }, style];
      var itemContentStyle = [radiusStyle, theme.padding && parseToStyle(theme.padding, 'padding'), contentStyle];
      return _react2.default.createElement(
        _styled2.StyledItem,
        { style: itemStyle, disabled: true, __source: {
            fileName: _jsxFileName,
            lineNumber: 234
          }
        },
        _react2.default.createElement(
          _styled2.StyledItemContent,
          { style: itemContentStyle, __source: {
              fileName: _jsxFileName,
              lineNumber: 235
            }
          },
          this.renderItem(true),
          this.renderSlider(),
          this.renderItem(false)
        )
      );
    }
  }]);

  return SliderItem;
}(_react.Component);

SliderItem.propTypes = _extends({}, _slider2.default.propTypes, {
  theme: _propTypes2.default.shape({
    iconColor: _reactNative.ColorPropType,
    descFontColor: _reactNative.ColorPropType,
    cellBg: _reactNative.ColorPropType,
    cellRadius: _propTypes2.default.number,
    margin: _propTypes2.default.array,
    padding: _propTypes2.default.array
  }),

  iconType: _propTypes2.default.oneOf(['auto', 'image', 'iconfont', 'text']),

  actionType: _propTypes2.default.oneOf(['auto', 'image', 'iconfont', 'text']),

  Icon: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func, _propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool, _propTypes2.default.object]),

  Action: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func, _propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool, _propTypes2.default.object]),

  iconSize: _propTypes2.default.number,

  iconColor: _reactNative.ColorPropType,

  style: _reactNative.ViewPropTypes.style,

  contentStyle: _reactNative.ViewPropTypes.style,

  textStyle: _reactNative.Text.propTypes.style,

  sliderStyle: _reactNative.ViewPropTypes.style,

  imageFollowIconColor: _propTypes2.default.bool,

  useART: _propTypes2.default.bool
});
SliderItem.defaultProps = {
  theme: {},
  iconType: 'auto',
  actionType: 'auto',
  Icon: null,
  Action: null,
  iconSize: 17,
  iconColor: null,
  style: null,
  contentStyle: null,
  textStyle: null,
  sliderStyle: null,
  imageFollowIconColor: true,
  useART: false
};
exports.default = SliderItem;