Object.defineProperty(exports, "__esModule", {
  value: true
});
var _jsxFileName = 'src/components/TYLists/list.js';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _theme = require('../theme');

var _utils = require('../../utils');

var _styled = require('./styled');

var _listItem = require('./list-item');

var _listItem2 = _interopRequireDefault(_listItem);

var _checkboxItem = require('./items/checkbox-item');

var _checkboxItem2 = _interopRequireDefault(_checkboxItem);

var _inputItem = require('./items/input-item');

var _inputItem2 = _interopRequireDefault(_inputItem);

var _sliderItem = require('./items/slider-item');

var _sliderItem2 = _interopRequireDefault(_sliderItem);

var _switchItem = require('./items/switch-item');

var _switchItem2 = _interopRequireDefault(_switchItem);

var _switchButton = require('../switch-button');

var _switchButton2 = _interopRequireDefault(_switchButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var get = _utils.CoreUtils.get;
var cx = _utils.RatioUtils.convertX;
var getTheme = _utils.ThemeUtils.getTheme,
    ThemeConsumer = _utils.ThemeUtils.ThemeConsumer;

var TYFlatList = function (_Component) {
  _inherits(TYFlatList, _Component);

  function TYFlatList() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TYFlatList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TYFlatList.__proto__ || Object.getPrototypeOf(TYFlatList)).call.apply(_ref, [this].concat(args))), _this), _this.renderItem = function (_ref2) {
      var item = _ref2.item,
          otherData = _objectWithoutProperties(_ref2, ['item']);

      var useART = _this.props.useART;

      var value = item.value,
          SwitchButtonProps = item.SwitchButtonProps,
          renderItem = item.renderItem,
          listItemProps = _objectWithoutProperties(item, ['value', 'SwitchButtonProps', 'renderItem']);

      if (typeof renderItem === 'function') {
        return renderItem(_extends({ item: item }, otherData));
      }
      if (typeof value === 'boolean') {
        return _react2.default.createElement(_switchItem2.default, _extends({ value: value, useART: useART }, listItemProps, SwitchButtonProps, {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 76
          }
        }));
      } else if (typeof value !== 'undefined') {
        var descFontColor = get(item, 'theme.descFontColor');
        var valueStyle = [descFontColor && { color: descFontColor }, get(item, 'styles.valueText')];
        return _react2.default.createElement(_listItem2.default, _extends({
          useART: useART
        }, listItemProps, {
          Action: _react2.default.createElement(
            _reactNative.View,
            { style: { flexDirection: 'row', alignItems: 'center' }, __source: {
                fileName: _jsxFileName,
                lineNumber: 85
              }
            },
            _react2.default.createElement(
              _styled.StyledValueText,
              { style: valueStyle, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 86
                }
              },
              value
            ),
            typeof listItemProps.Action === 'function' ? listItemProps.Action() : listItemProps.Action
          ),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 81
          }
        }));
      }
      return _react2.default.createElement(_listItem2.default, _extends({ useART: useART }, listItemProps, {
        __source: {
          fileName: _jsxFileName,
          lineNumber: 95
        }
      }));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TYFlatList, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          contentContainerStyle = _props.contentContainerStyle,
          separatorStyle = _props.separatorStyle,
          data = _props.data,
          flatListRef = _props.flatListRef,
          flatListProps = _objectWithoutProperties(_props, ['contentContainerStyle', 'separatorStyle', 'data', 'flatListRef']);

      return _react2.default.createElement(
        ThemeConsumer,
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 107
          }
        },
        function (globalTheme) {
          var propsWithTheme = _extends({}, _this2.props, { theme: globalTheme });
          var contentStyle = [{
            backgroundColor: getTheme(propsWithTheme, 'list.boardBg', _theme.defaultTheme.list.light.boardBg)
          }, contentContainerStyle];
          var sepStyle = [{
            marginLeft: cx(16),
            height: _reactNative.StyleSheet.hairlineWidth,
            backgroundColor: getTheme(propsWithTheme, 'list.cellLine', _theme.defaultTheme.list.light.cellLine)
          }, separatorStyle];
          return _react2.default.createElement(_reactNative.FlatList, _extends({
            contentContainerStyle: contentStyle,
            ItemSeparatorComponent: function ItemSeparatorComponent() {
              return _react2.default.createElement(_reactNative.View, { style: sepStyle, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 135
                }
              });
            },
            renderItem: _this2.renderItem,
            data: data,
            keyExtractor: function keyExtractor(item) {
              return item.key;
            },
            showsVerticalScrollIndicator: false
          }, flatListProps, {
            ref: flatListRef,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 133
            }
          }));
        }
      );
    }
  }]);

  return TYFlatList;
}(_react.Component);

TYFlatList.Item = _listItem2.default;
TYFlatList.CheckboxItem = _checkboxItem2.default;
TYFlatList.InputItem = _inputItem2.default;
TYFlatList.SliderItem = _sliderItem2.default;
TYFlatList.SwitchItem = _switchItem2.default;
TYFlatList.propTypes = _extends({}, _reactNative.FlatList.propTypes, {
  data: _propTypes2.default.arrayOf(_propTypes2.default.shape(_extends({
    renderItem: _propTypes2.default.func,
    SwitchButtonProps: _propTypes2.default.shape(_extends({}, _switchButton2.default.propTypes))
  }, _listItem2.default.propTypes))).isRequired,

  separatorStyle: _reactNative.ViewPropTypes.style,

  flatListRef: _propTypes2.default.func,

  useART: _propTypes2.default.bool
});
TYFlatList.defaultProps = {
  separatorStyle: null,
  flatListRef: null,
  useART: false
};
exports.default = TYFlatList;