Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DialogFooter = undefined;
var _jsxFileName = 'src/components/dialog/footer.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _TYText = require('../TYText');

var _TYText2 = _interopRequireDefault(_TYText);

var _styled = require('./styled');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DialogFooter = exports.DialogFooter = function (_React$Component) {
  _inherits(DialogFooter, _React$Component);

  function DialogFooter(props) {
    _classCallCheck(this, DialogFooter);

    var _this = _possibleConstructorReturn(this, (DialogFooter.__proto__ || Object.getPrototypeOf(DialogFooter)).call(this, props));

    _this._handlePressIn = function (isConfirm) {
      if (isConfirm) {
        _this.setState({
          pressConfirmActive: true
        });
      } else {
        _this.setState({
          pressCancelActive: true
        });
      }
    };

    _this._handlePressOut = function (isConfirm) {
      if (isConfirm) {
        _this.setState({
          pressConfirmActive: false
        });
      } else {
        _this.setState({
          pressCancelActive: false
        });
      }
    };

    _this.state = {
      pressConfirmActive: false,
      pressCancelActive: false
    };
    return _this;
  }

  _createClass(DialogFooter, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          cancelText = _props.cancelText,
          cancelTextStyle = _props.cancelTextStyle,
          cancelAccessibilityLabel = _props.cancelAccessibilityLabel,
          confirmText = _props.confirmText,
          confirmTextStyle = _props.confirmTextStyle,
          confirmAccessibilityLabel = _props.confirmAccessibilityLabel,
          confirmDisabled = _props.confirmDisabled,
          onCancel = _props.onCancel,
          onConfirm = _props.onConfirm;
      var _state = this.state,
          pressConfirmActive = _state.pressConfirmActive,
          pressCancelActive = _state.pressCancelActive;

      return _react2.default.createElement(
        _styled.StyledFooter,
        { style: style, __source: {
            fileName: _jsxFileName,
            lineNumber: 61
          }
        },
        !!cancelText && _react2.default.createElement(
          _styled.StyledCancelButton,
          {
            bordered: !!cancelText && !!confirmText,
            accessibilityLabel: cancelAccessibilityLabel,
            onPressIn: function onPressIn() {
              return _this2._handlePressIn(false);
            },
            onPressOut: function onPressOut() {
              return _this2._handlePressOut(false);
            },
            onPress: onCancel,
            pressActive: pressCancelActive,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 63
            }
          },
          _react2.default.createElement(
            _styled.StyledCancelText,
            { style: cancelTextStyle, __source: {
                fileName: _jsxFileName,
                lineNumber: 71
              }
            },
            cancelText
          )
        ),
        !!confirmText && _react2.default.createElement(
          _styled.StyledConfirmButton,
          {
            accessibilityLabel: confirmAccessibilityLabel,
            onPress: onConfirm,
            onPressIn: function onPressIn() {
              return _this2._handlePressIn(true);
            },
            onPressOut: function onPressOut() {
              return _this2._handlePressOut(true);
            },
            disabled: confirmDisabled,
            pressActive: pressConfirmActive,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 75
            }
          },
          _react2.default.createElement(
            _styled.StyledConfirmText,
            { style: confirmTextStyle, __source: {
                fileName: _jsxFileName,
                lineNumber: 83
              }
            },
            confirmText
          )
        )
      );
    }
  }]);

  return DialogFooter;
}(_react2.default.Component);

DialogFooter.propTypes = {
  style: _reactNative.ViewPropTypes.style,
  cancelText: _propTypes2.default.string,
  cancelTextStyle: _TYText2.default.propTypes.style,
  cancelAccessibilityLabel: _propTypes2.default.string,
  confirmText: _propTypes2.default.string,
  confirmTextStyle: _TYText2.default.propTypes.style,
  confirmAccessibilityLabel: _propTypes2.default.string,
  onCancel: _propTypes2.default.func,
  onConfirm: _propTypes2.default.func,
  confirmDisabled: _propTypes2.default.bool
};

DialogFooter.defaultProps = {
  style: null,
  cancelText: '',
  cancelTextStyle: null,
  cancelAccessibilityLabel: 'Dialog.Cancel',
  confirmText: '',
  confirmTextStyle: null,
  confirmAccessibilityLabel: 'Dialog.Confirm',
  onCancel: null,
  onConfirm: null,
  confirmDisabled: false
};

exports.default = DialogFooter;