Object.defineProperty(exports, "__esModule", {
  value: true
});
var _jsxFileName = 'src/components/dialog/index.js';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _modal = require('../modal');

var _modal2 = _interopRequireDefault(_modal);

var _alert = require('./alert');

var _alert2 = _interopRequireDefault(_alert);

var _confirm = require('./confirm');

var _confirm2 = _interopRequireDefault(_confirm);

var _prompt = require('./prompt');

var _prompt2 = _interopRequireDefault(_prompt);

var _checkbox = require('./checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _list = require('./list');

var _list2 = _interopRequireDefault(_list);

var _custom = require('./custom');

var _custom2 = _interopRequireDefault(_custom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var commonProps = {
  onCancel: _modal2.default.close,
  onConfirm: _modal2.default.close
};

var commonModalProps = {
  alignContainer: 'center',
  onMaskPress: function onMaskPress() {}
};

var Dialog = {
  alert: function alert(props, modalOpts) {
    var alertProps = _extends({}, commonProps, props);
    var modalProps = _extends({}, commonModalProps, modalOpts);
    _modal2.default.render(_react2.default.createElement(_alert2.default, _extends({}, alertProps, {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 25
      }
    })), modalProps);
  },

  confirm: function confirm(props, modalOpts) {
    var confirmProps = _extends({}, commonProps, props);
    var modalProps = _extends({}, commonModalProps, modalOpts);
    _modal2.default.render(_react2.default.createElement(_confirm2.default, _extends({}, confirmProps, {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 31
      }
    })), modalProps);
  },

  prompt: function prompt(props, modalOpts) {
    var promptProps = _extends({}, commonProps, props);
    var modalProps = _extends({}, commonModalProps, modalOpts, { useKeyboardView: true });
    _modal2.default.render(_react2.default.createElement(_prompt2.default, _extends({}, promptProps, {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 37
      }
    })), modalProps);
  },

  checkbox: function checkbox(props, modalOpts) {
    var checkboxProps = _extends({}, commonProps, props);
    var modalProps = _extends({}, commonModalProps, modalOpts);
    _modal2.default.render(_react2.default.createElement(_checkbox2.default, _extends({}, checkboxProps, {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 43
      }
    })), modalProps);
  },

  list: function list(props, modalOpts) {
    var listProps = _extends({}, commonProps, props);
    var modalProps = _extends({}, commonModalProps, modalOpts);
    _modal2.default.render(_react2.default.createElement(_list2.default, _extends({}, listProps, {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49
      }
    })), modalProps);
  },

  custom: function custom(props, modalOpts) {
    var customProps = _extends({}, commonProps, props);
    var modalProps = _extends({}, commonModalProps, modalOpts);
    _modal2.default.render(_react2.default.createElement(_custom2.default, _extends({}, customProps, {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 61
      }
    })), modalProps);
  },

  close: _modal2.default.close
};

exports.default = Dialog;