Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MOTION_TYPES = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsxFileName = 'src/components/dialog/withMotion.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _index = require('../motion/index');

var _index2 = _interopRequireDefault(_index);

var _modal = require('../modal');

var _modal2 = _interopRequireDefault(_modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MOTION_TYPES = exports.MOTION_TYPES = Object.keys(_index2.default).concat('none').filter(function (v) {
  return v !== 'Toast';
});

var withMotion = function withMotion(WrapperComponent) {
  var wrapperName = WrapperComponent.displayName || WrapperComponent.name;

  var EnhancedComponent = function (_React$Component) {
    _inherits(EnhancedComponent, _React$Component);

    function EnhancedComponent(props) {
      _classCallCheck(this, EnhancedComponent);

      var _this = _possibleConstructorReturn(this, (EnhancedComponent.__proto__ || Object.getPrototypeOf(EnhancedComponent)).call(this, props));

      _this._handleHide = function () {
        typeof _this.actionFn === 'function' && _this.actionFn();
      };

      _this._handleCancel = function () {
        var onCancel = _this.props.onCancel;

        _this.setState({ show: false }, function () {
          _this.actionFn = function () {
            return typeof onCancel === 'function' && onCancel();
          };
        });
      };

      _this._handleConfirm = function (value) {
        var onConfirm = _this.props.onConfirm;

        typeof onConfirm === 'function' && onConfirm(value, {
          close: function close(callBack) {
            _this.setState({ show: false });
            _this.actionFn = function () {
              _modal2.default.close();
              typeof callBack === 'function' && callBack();
            };
          }
        });
      };

      var motionType = props.motionType;

      if (MOTION_TYPES.indexOf(motionType) === -1) {
        var _ret;

        console.error('withMotion: motion type must be one of ' + JSON.stringify(MOTION_TYPES) + ', but receive ' + motionType);
        return _ret = _reactNative.View, _possibleConstructorReturn(_this, _ret);
      }
      _this.state = {
        show: true
      };
      return _this;
    }

    _createClass(EnhancedComponent, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            motionType = _props.motionType,
            motionConfig = _props.motionConfig;

        if (motionType === 'none') {
          return _react2.default.createElement(WrapperComponent, _extends({}, this.props, {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 79
            }
          }));
        }
        var MotionComp = _index2.default[motionType];
        return _react2.default.createElement(
          MotionComp,
          _extends({}, motionConfig, { show: this.state.show, onHide: this._handleHide, __source: {
              fileName: _jsxFileName,
              lineNumber: 83
            }
          }),
          _react2.default.createElement(WrapperComponent, _extends({}, this.props, {
            onCancel: this._handleCancel,
            onConfirm: this._handleConfirm,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 84
            }
          }))
        );
      }
    }]);

    return EnhancedComponent;
  }(_react2.default.Component);

  EnhancedComponent.displayName = 'withMotion(' + wrapperName + ')';
  EnhancedComponent.propTypes = _extends({}, WrapperComponent.propTypes, {
    motionType: _propTypes2.default.oneOf(MOTION_TYPES),
    motionConfig: _propTypes2.default.object
  });
  EnhancedComponent.defaultProps = _extends({
    motionType: 'ScaleFadeIn',
    motionConfig: {
      initScale: 0.8,
      finalScale: 0.9
    }
  }, WrapperComponent.defaultProps);

  return (0, _hoistNonReactStatics2.default)(EnhancedComponent, WrapperComponent);
};

exports.default = withMotion;