Object.defineProperty(exports, "__esModule", {
  value: true
});
var _jsxFileName = 'src/components/layout/topbar/TopBarContent.js';

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _styled = require('./styled');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TopBarContent = function TopBarContent(_ref) {
  var style = _ref.style,
      color = _ref.color,
      title = _ref.title,
      titleStyle = _ref.titleStyle,
      subTitle = _ref.subTitle,
      subTitleStyle = _ref.subTitleStyle,
      position = _ref.position,
      children = _ref.children,
      onPress = _ref.onPress;

  var titleColor = color;
  var subTitleColor = titleColor && (0, _color2.default)(color).alpha(0.6).rgbString();
  return _react2.default.createElement(
    _reactNative.TouchableWithoutFeedback,
    { accessibilityLabel: 'TopBar_Btn_Title', onPress: onPress, __source: {
        fileName: _jsxFileName,
        lineNumber: 25
      }
    },
    _react2.default.createElement(
      _styled.StyledTopBarContent,
      { style: style, align: position, __source: {
          fileName: _jsxFileName,
          lineNumber: 26
        }
      },
      !!title && _react2.default.createElement(
        _styled.StyledTopBarTitle,
        { style: titleStyle, color: color, numberOfLines: 1, __source: {
            fileName: _jsxFileName,
            lineNumber: 28
          }
        },
        title
      ),
      !!subTitle && _react2.default.createElement(
        _styled.StyledTopBarSubTitle,
        { style: subTitleStyle, color: subTitleColor, numberOfLines: 1, __source: {
            fileName: _jsxFileName,
            lineNumber: 33
          }
        },
        subTitle
      ),
      children
    )
  );
};

TopBarContent.displayName = 'TopBar.Content';

TopBarContent.propTypes = {
  style: _reactNative.ViewPropTypes.style,

  color: _propTypes2.default.string,

  title: _propTypes2.default.string,

  titleStyle: _reactNative.Text.propTypes.style,

  subTitle: _propTypes2.default.string,

  subTitleStyle: _reactNative.Text.propTypes.style,

  position: _propTypes2.default.oneOf(['left', 'center', 'right']),

  children: _propTypes2.default.any,

  onPress: _propTypes2.default.func
};

TopBarContent.defaultProps = {
  style: null,
  color: null,
  title: '',
  titleStyle: null,
  subTitle: '',
  subTitleStyle: null,
  position: 'center',
  children: null,
  onPress: null
};

exports.default = TopBarContent;