Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PickerView = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsxFileName = 'src/components/picker-view/index.android.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _index = require('./picker/index.android');

var _index2 = _interopRequireDefault(_index);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getTheme = _utils.ThemeUtils.getTheme,
    ThemeConsumer = _utils.ThemeUtils.ThemeConsumer;


var height = 216;

var Item = function (_Component) {
  _inherits(Item, _Component);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).apply(this, arguments));
  }

  _createClass(Item, [{
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Item;
}(_react.Component);

Item.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool]),
  label: _propTypes2.default.string
};

var PickerView = exports.PickerView = function (_Component2) {
  _inherits(PickerView, _Component2);

  function PickerView(props) {
    _classCallCheck(this, PickerView);

    var _this2 = _possibleConstructorReturn(this, (PickerView.__proto__ || Object.getPrototypeOf(PickerView)).call(this, props));

    _this2.stateFromProps = _this2._stateFromProps.bind(_this2);
    _this2._onChange = _this2._onChange.bind(_this2);

    _this2.state = _this2.stateFromProps(props);
    return _this2;
  }

  _createClass(PickerView, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState(this.stateFromProps(nextProps));
    }
  }, {
    key: '_stateFromProps',
    value: function _stateFromProps(props) {
      var selectedIndex = 0;
      var items = [];
      _react2.default.Children.toArray(props.children).forEach(function (child, index) {
        if (child.props.value === props.selectedValue) {
          selectedIndex = index;
        }
        items.push({
          value: child.props.value,
          label: child.props.label
        });
      });
      return { selectedIndex: selectedIndex, items: items };
    }
  }, {
    key: '_onChange',
    value: function _onChange(event) {
      var newIndex = event.nativeEvent.newIndex;

      if (this.props.onValueChange) {
        this.props.onValueChange(this.state.items[newIndex].value, newIndex);
      }

      if (this._picker && this.state.selectedIndex !== newIndex) {
        this._picker.setNativeProps({
          selectedIndex: this.state.selectedIndex
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var style = _reactNative.StyleSheet.flatten(this.props.style);
      var loop = this.props.loop;


      return _react2.default.createElement(_index2.default, {
        style: [{
          height: height,
          backgroundColor: '#fff'
        }, style],
        accessibilityLabel: this.props.accessibilityLabel,
        items: this.state.items,
        itemTextColor: this.props.itemTextColor,
        selectedItemTextColor: this.props.selectedItemTextColor,
        dividerColor: this.props.dividerColor,
        visibleItemCount: this.props.visibleItemCount,
        itemAlign: this.props.itemAlign,
        selectedValue: this.state.selectedIndex,
        textSize: this.props.textSize,
        loop: loop,
        onValueChange: this._onChange,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 121
        }
      });
    }
  }]);

  return PickerView;
}(_react.Component);

PickerView.propTypes = _extends({}, _reactNative.ViewPropTypes, {
  accessibilityLabel: _propTypes2.default.string,

  itemTextColor: _reactNative.ColorPropType,

  selectedItemTextColor: _reactNative.ColorPropType,

  dividerColor: _reactNative.ColorPropType,

  visibleItemCount: _propTypes2.default.number,

  onValueChange: _propTypes2.default.func,

  selectedValue: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool]),

  children: _propTypes2.default.node.isRequired,

  loop: _propTypes2.default.bool
});
PickerView.defaultProps = {
  accessibilityLabel: 'PickerView',
  loop: false,
  itemTextColor: '#cccccc',
  selectedItemTextColor: 'black',
  dividerColor: '#cccccc',
  visibleItemCount: 5,
  itemAlign: 'center',
  textSize: 20
};


PickerView.Item = Item;
PickerView.height = height;

var ThemedPickerView = function ThemedPickerView(props) {
  var localTheme = props.theme,
      itemStyle = props.itemStyle,
      rest = _objectWithoutProperties(props, ['theme', 'itemStyle']);

  return _react2.default.createElement(
    ThemeConsumer,
    {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 151
      }
    },
    function (fullTheme) {
      var theme = _extends({}, fullTheme, {
        picker: _extends({}, fullTheme.picker, localTheme)
      });
      var propsWithTheme = _extends({ theme: theme }, rest);
      var textSize = getTheme(propsWithTheme, 'picker.fontSize');
      var itemTextColor = getTheme(propsWithTheme, 'picker.fontColor');
      var dividerColor = getTheme(propsWithTheme, 'picker.dividerColor');
      return _react2.default.createElement(PickerView, _extends({
        textSize: textSize,
        itemTextColor: itemTextColor,
        selectedItemTextColor: itemTextColor,
        dividerColor: dividerColor
      }, rest, {
        __source: {
          fileName: _jsxFileName,
          lineNumber: 162
        }
      }));
    }
  );
};

ThemedPickerView.Item = Item;

ThemedPickerView.propTypes = {
  theme: _propTypes2.default.shape({
    fontSize: _propTypes2.default.number,
    fontColor: _reactNative.ColorPropType,
    dividerColor: _reactNative.ColorPropType
  })
};

ThemedPickerView.defaultProps = {
  theme: {}
};

exports.default = ThemedPickerView;