Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsxFileName = 'src/components/switch-button/index.js';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactNative = require('react-native');

var _switchButton = require('./switch-button');

var _switchButton2 = _interopRequireDefault(_switchButton);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var getTheme = _utils.ThemeUtils.getTheme,
    ThemeConsumer = _utils.ThemeUtils.ThemeConsumer;


var ThemedSwitchButton = function ThemedSwitchButton(props) {
  var localTheme = props.theme,
      size = props.size,
      rest = _objectWithoutProperties(props, ['theme', 'size']);

  return _react2.default.createElement(
    ThemeConsumer,
    {
      __source: {
        fileName: _jsxFileName,
        lineNumber: 12
      }
    },
    function (globalTheme) {
      var theme = _extends({}, globalTheme, {
        switchButton: _extends({}, globalTheme.switchButton, localTheme)
      });
      var propsWithTheme = _extends({ theme: theme }, rest);
      var onTintColor = rest.onTintColor;

      var isGradient = onTintColor && typeof onTintColor === 'object';

      var hasText = rest.onText !== undefined && rest.offText !== undefined && !!rest.onText && !!rest.offText || rest.onText === undefined && rest.offText === undefined;
      var themedProps = {
        size: _extends({
          width: isGradient && hasText ? getTheme(propsWithTheme, 'switchButton.width') + 9 : getTheme(propsWithTheme, 'switchButton.width'),
          height: getTheme(propsWithTheme, 'switchButton.height'),
          activeSize: getTheme(propsWithTheme, 'switchButton.thumbSize'),
          margin: getTheme(propsWithTheme, 'switchButton.margin')
        }, size)
      };

      var keys = ['tintColor', 'onTintColor', 'thumbTintColor', 'onThumbTintColor'];
      keys.forEach(function (themeKey) {
        var path = 'switchButton.' + themeKey;
        themedProps[themeKey] = getTheme(propsWithTheme, path);
      });
      return _react2.default.createElement(_switchButton2.default, _extends({}, themedProps, rest, {
        __source: {
          fileName: _jsxFileName,
          lineNumber: 47
        }
      }));
    }
  );
};

ThemedSwitchButton.propTypes = _extends({}, _switchButton2.default.propTypes, {
  theme: _propTypes2.default.shape({
    width: _propTypes2.default.number,

    height: _propTypes2.default.number,

    thumbSize: _propTypes2.default.number,

    margin: _propTypes2.default.number,

    tintColor: _reactNative.ColorPropType,

    onTintColor: _reactNative.ColorPropType,

    thumbTintColor: _reactNative.ColorPropType,

    onThumbTintColor: _reactNative.ColorPropType
  })
});

ThemedSwitchButton.defaultProps = {
  theme: null
};

exports.default = ThemedSwitchButton;